<template>
  <div class="date">
    <b-row>
      <b-col sm="12" md="6" class="mb-3">
        <label for="checkIn">Check-in</label>
        <b-form-datepicker
          v-model="checkInCloned"
          v-validate="'required'"
          id="checkIn"
          name="checkIn"
          :min="today"
          :max="checkOutCloned"
          locale="en"
          @input="value => setCheckIn(value)" />
      </b-col>
      <b-col sm="12" md="6" class="mb-3">
        <label for="checkOut">Check-out</label>
        <b-form-datepicker
          v-model="checkOutCloned"
          v-validate="'required'"
          id="checkOut"
          name="checkOut"
          :min="checkInCloned"
          locale="en"
          @input="value => setCheckOut(value)" />
      </b-col>
    </b-row>
  </div>
</template>

<script>
export default {
  data () {
    return {
      now: new Date(),
      checkInCloned: '',
      checkOutCloned: ''
    }
  },

  props: {
    checkIn: {
      type: String,
      required: true
    },
    checkOut: {
      type: String,
      required: true
    }
  },

  computed: {
    today () {
      return new Date(this.now.getFullYear(), this.now.getMonth(), this.now.getDate())
    }
  },

  methods: {
    setCheckIn (value) {
      this.checkInCloned = value
      this.$emit('setCheckIn', value)
    },
    setCheckOut (value) {
      this.checkOutCloned = value
      this.$emit('setCheckOut', value)
    },
    validate () {
      this.$validator.validateAll()
    }
  },

  beforeMount () {
    this.checkInCloned = this.checkIn
    this.checkOutCloned = this.checkOut
  }
}
</script>
